Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 159925 - RFE: Extend repodata format for PreRequires
Summary: RFE: Extend repodata format for PreRequires
Keywords:
Status: CLOSED UPSTREAM
Alias: None
Product: Fedora
Classification: Fedora
Component: yum
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jeremy Katz
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2005-06-09 10:53 UTC by Phil Knirsch
Modified: 2015-03-05 01:14 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2005-06-10 15:52:05 UTC


Attachments (Terms of Use)

Description Phil Knirsch 2005-06-09 10:53:14 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.8) Gecko/20050524 Fedora/1.0.4-4 Firefox/1.0.4

Description of problem:
The current repodata format limits the PreRequires to the "legacy" pre-requires which are written like this in a spec file:

PreReq: foo

Autodetected install or erase requires (Requires(post) and Requires(pre)) are completely ignored.

The following extention to the repodata format would allow those prerequires to be honred and used as well:

Add a 'type' property to the rpm:entry for requires which can have the following values:

  'legacy': The ones that are currently supported
  'pre': The Requires(pre) prereqs
  'post': The Requires(post) prereqs
  'preun': The Requires(preun) prereqs
  'postun': The Requires(postun) prereqs

If 'type' is missing but 'pre' is set to '1' then 'legacy' is assumed which would allow 100% compatibility with the old repodata format.

The general benefit would be that by including these prereqs the repodata could be used to do complete depresolving and ordering without any real rpm headers.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Grab all requires form current rpms. 
2. Detect all forms of prereqs and install and erase loops
3. Try to break those loops without the pre, post, preun and postun prereqs can result in wrong ordering
  

Additional info:

Comment 1 Phil Knirsch 2005-06-09 10:55:23 UTC
Ah, forgot in the upper part:

Not only autodetected install and erase prereqs are a problem but the ones you
write like this:

  Requires(pre): foo
  Requires(post): foo
  Requires(preun): foo
  Requires(postun): foo

Read ya, Phil

Comment 2 Jeremy Katz 2005-06-10 15:52:05 UTC
This should be discussed on the metadata mailing list:
  https://lists.dulug.duke.edu/mailman/listinfo/rpm-metadata


Note You need to log in before you can comment on or make changes to this bug.